CREATE TABLE IF NOT EXISTS xplugin_ws_dashbar_events (
    type      INT       DEFAULT 0,
    runtime   FLOAT     DEFAULT 0,
    visitorID VARCHAR(32),
    cookieID  VARCHAR(32),
    timestamp TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    data      TEXT NULL DEFAULT NULL,
    INDEX (`visitorID`),
    INDEX (`cookieID`)
);

CREATE TABLE IF NOT EXISTS xplugin_ws_dashbar_cookie (
    cookieID VARCHAR(32),
    kKunde   INT NULL  DEFAULT NULL,
    created  TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`cookieID`),
    INDEX (`kKunde`)
);

CREATE TABLE IF NOT EXISTS xplugin_ws_dashbar_visitor (
    id          VARCHAR(32),
    cookieID    VARCHAR(32),
    basket      FLOAT            DEFAULT 0,
    basketItems INT              DEFAULT 0,
    orderID     INT         NULL DEFAULT NULL,
    orderNumber VARCHAR(64) NULL DEFAULT NULL,
    city        VARCHAR(128)     DEFAULT '',
    country     VARCHAR(2)       DEFAULT '',
    browser     VARCHAR(64)      DEFAULT '',
    os          VARCHAR(64)      DEFAULT '',
    device      VARCHAR(64)      DEFAULT '',
    userAgent   VARCHAR(512)     DEFAULT '',
    entryPage   VARCHAR(512)     DEFAULT '',
    exitPage    VARCHAR(512)     DEFAULT '',
    referrer    VARCHAR(512)     DEFAULT '',
    lastAction  TIMESTAMP   NULL DEFAULT NULL,
    created     TIMESTAMP        DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`),
    INDEX (`cookieID`)
);